//+------------------------------------------------------------------+
//|                                                Cronex Taichi.mq4 |
//|                                                                  |
//| original indicator developed by cronex                           |
//| improvments and cleanup made by newdigital and mladen            |
//+------------------------------------------------------------------+
#property  copyright "www.forex-station.com"
#property  link      "www.forex-station.com"

#property  indicator_chart_window
#property  indicator_buffers 6
#property  indicator_color1  DeepSkyBlue
#property  indicator_color2  Red
#property  indicator_color3  LimeGreen
#property  indicator_color4  Orange
#property  indicator_color5  DimGray
#property  indicator_color6  DimGray
#property  indicator_width1  2
#property  indicator_width4  2
#property  indicator_style5  STYLE_DOT
#property  indicator_style6  STYLE_DOT

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Tenkan          =  9;
extern int    Kijun           = 26;
extern int    Senkou          = 52;
extern bool   alertsOn        = true;              // Turn alerts on?
extern bool   alertsOnCurrent = false;             // Alerts on still open bar?
extern bool   alertsMessage   = true;              // Alerts should show popup message?
extern bool   alertsSound     = false;             // Alerts should play a sound?
extern bool   alertsNotify    = false;             // Alerts should send notification?
extern bool   alertsEmail     = false;             // Alerts should send email?
extern bool   Interpolate     = true;


extern string             button_note1          = "------------------------------";
extern int                btn_Subwindow = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "crta";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                            
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern string             btn_pressed           = "crta OFF";            
extern string             btn_unpressed         = "crta ON";
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 200;                                 
extern int                button_y              = 0;                                   
extern int                btn_Width             = 65;                                 
extern int                btn_Height            = 20;                                
extern string             soundBT               = "tick.wav";  
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix ,buttonId ;

//
//
//
//
//

double     TaichiBuffer[];
double     TaichiForBuffer[];
double     SignalBuffer[];
double     SSignalBuffer[];
double     FlatBuffer1[];
double     FlatBuffer2[],trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//
//
//

int init()
{
   IndicatorDigits(Digits+1);
      IndicatorBuffers(7);
      SetIndexBuffer(0,TaichiBuffer); SetIndexStyle(0,DRAW_LINE);   SetIndexLabel(0,"Taichi");
      SetIndexBuffer(1,SignalBuffer);  SetIndexStyle(1,DRAW_LINE);  SetIndexLabel(1,"Signal");
      SetIndexBuffer(2,SSignalBuffer);  SetIndexStyle(2,DRAW_LINE); SetIndexLabel(2,"SSignal");
      SetIndexBuffer(3,TaichiForBuffer);SetIndexStyle(3,DRAW_LINE); SetIndexLabel(3,"TaichiFor"); 
      SetIndexBuffer(4,FlatBuffer1);     SetIndexLabel(4,"FlatUp");    SetIndexStyle(4,DRAW_HISTOGRAM);
      SetIndexBuffer(5,FlatBuffer2);     SetIndexLabel(5,"FlatDn");    SetIndexStyle(5,DRAW_HISTOGRAM);
      SetIndexBuffer(6,trend);

   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   timeFrame         = stringToTimeFrame(TimeFrame);
   returnBars        = (TimeFrame=="returnBars");    if (returnBars) return(0);
   calculateValue    = (TimeFrame=="CalculateValue"); 
            if (!calculateValue) SetIndexShift(3,Kijun*timeFrame/Period());

   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(timeFrame)+" Cronex Taichi");
   
    IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(WindowExpertName());
   IndicatorDigits(Digits);
      double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
   show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix+btn_text;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x);
   
   
   return(0);
}


void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (ChartID(),buttonID);
      ObjectCreate (ChartID(),buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
      ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
int deinit()
{

 ObjectsDeleteAll(0,"crta");
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
  

return(0);
}

 bool recalc = true;
 void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
void OnChartEvent(const int id, 
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {
   if (soundBT!="") PlaySound(soundBT);     
   }
}
//
//
//
//

int start()
{
  handleButtonClicks();
   recalc = false;
   
   start2();
  
   
        SetIndexStyle(0,DRAW_LINE);
        SetIndexStyle(1,DRAW_LINE);
        SetIndexStyle(2,DRAW_LINE);
        SetIndexStyle(3,DRAW_LINE);
        SetIndexStyle(4,DRAW_HISTOGRAM);
        SetIndexStyle(5,DRAW_HISTOGRAM);
       
      
   
   if (show_data)
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_unpressed);
      }
      else
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_pressed);
      SetIndexStyle(0,DRAW_NONE);
        SetIndexStyle(1,DRAW_NONE);
        SetIndexStyle(2,DRAW_NONE);
        SetIndexStyle(3,DRAW_NONE);
        SetIndexStyle(4,DRAW_NONE);
        SetIndexStyle(5,DRAW_NONE);
       
      
   
      //template code     
      }
       return(0);
      }
      
       int start2()
  {
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { TaichiBuffer[0] = MathMin(limit+Kijun,Bars-1); return(0); }

   //
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(i=-Kijun; i<limit; i++)
      {
         double TenkanSen   = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_TENKANSEN,i);
         double KijunSen    = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_KIJUNSEN,i);
         double SenkouSpanA = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANA,i);
         double SenkouSpanB = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANB,i);
         double ChinkouSpan = iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_CHINKOUSPAN,i);      

         TaichiForBuffer[i+Kijun] = (SenkouSpanA+SenkouSpanB)/2.0;
            if (i>=0)
               TaichiBuffer[i] = (TenkanSen+KijunSen+SenkouSpanA+SenkouSpanB)/4.0;
      }
      
      //
      //
      //
      //
      //
      
      for(i=0; i<limit; i++)
      {
         SignalBuffer[i]  = iMAOnArray(TaichiBuffer,0,Kijun,0,MODE_LWMA,i);
         SSignalBuffer[i] = iMAOnArray(TaichiBuffer,0,Senkou,0,MODE_LWMA,i);   
         FlatBuffer1[i]   = 0;
         FlatBuffer2[i]   = 0;

         double FlatSE = iATR(NULL,0,20,i)/Point/2.0;
            if(MathAbs(((TaichiBuffer[i]-SignalBuffer[i])+(TaichiBuffer[i]- SSignalBuffer[i])+(SignalBuffer[i]-SSignalBuffer[i]))/3.0)<FlatSE*Point)
            {
               FlatBuffer1[i]=SignalBuffer[i]+FlatSE*Point;
               FlatBuffer2[i]=SignalBuffer[i]-FlatSE*Point;
            }
            trend[i] = (i<Bars-1) ? (TaichiBuffer[i]>TaichiForBuffer[i+Kijun]) ? 1 : (TaichiBuffer[i]<TaichiForBuffer[i+Kijun]) ? -1 : trend[i+1] : 0;
      }
      if (alertsOn)
      {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("crossing up");
         else  doAlert("crossing down");       
      }  
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         TaichiBuffer[i]    = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,Interpolate,button_note1,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,button_note2,0,y);
         SignalBuffer[i]    = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,Interpolate,button_note1,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,button_note2,1,y);
         SSignalBuffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,Interpolate,button_note1,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,button_note2,2,y);
         TaichiForBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,Interpolate,button_note1,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,button_note2,3,y);
         FlatBuffer1[i]     = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,Interpolate,button_note1,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,button_note2,4,y);
         FlatBuffer2[i]     = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",Tenkan,Kijun,Senkou,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,Interpolate,button_note1,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,button_note2,5,y);

         //
         //
         //
         //
         //
      
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               TaichiBuffer[i+k]    = TaichiBuffer[i]    + (TaichiBuffer[i+n]   - TaichiBuffer[i]   )*k/n;
               TaichiForBuffer[i+k] = TaichiForBuffer[i] + (TaichiForBuffer[i+n]- TaichiForBuffer[i])*k/n;
               SignalBuffer[i+k]    = SignalBuffer[i]    + (SignalBuffer[i+n]   - SignalBuffer[i]   )*k/n;
               SSignalBuffer[i+k]   = SSignalBuffer[i]   + (SSignalBuffer[i+n]  - SSignalBuffer[i]  )*k/n;
               FlatBuffer1[i+k]     = FlatBuffer1[i]     + (FlatBuffer1[i+n]    - FlatBuffer1[i]    )*k/n;
               FlatBuffer2[i+k]     = FlatBuffer2[i]     + (FlatBuffer2[i+n]    - FlatBuffer2[i]    )*k/n;
            }               
   }
   
   //
   //
   //
   //
   //
      
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" cronex tachi "+doWhat;
             if (alertsMessage)   Alert(message);
             if (alertsNotify)    SendNotification(message);
             if (alertsEmail)     SendMail(_Symbol+" cronex tachi ",message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
}

